//
//  AppDelegate.m
//  ZebraExam
//
//  Created by savin son on 3/19/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "AppDelegate.h"


static AppDelegate	*g_pApp;

AppDelegate*	getRootViewController()
{
	return g_pApp;
}




@implementation AppDelegate

@synthesize window = _window;
@synthesize tabBarController = _tabBarController;

@synthesize printerController;
@synthesize uiView_Lookup, uiView_PrintText, uiView_Msr, uiView_ImgBarcode;

- (void)dealloc
{
    [self releasePrinterController];
    
    [uiView_ImgBarcode release];
    [uiView_Msr release];
	[uiView_PrintText release];
	[uiView_Lookup release];
    
    
    [_window release];
    [_tabBarController release];
    [super dealloc];
}

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    self.window = [[[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]] autorelease];
    // Override point for customization after application launch.
#if 0
    UIViewController *viewController1, *viewController2;
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        viewController1 = [[[FirstViewController alloc] initWithNibName:@"FirstViewController_iPhone" bundle:nil] autorelease];
        viewController2 = [[[SecondViewController alloc] initWithNibName:@"SecondViewController_iPhone" bundle:nil] autorelease];
    } else {
        viewController1 = [[[FirstViewController alloc] initWithNibName:@"FirstViewController_iPad" bundle:nil] autorelease];
        viewController2 = [[[SecondViewController alloc] initWithNibName:@"SecondViewController_iPad" bundle:nil] autorelease];
    }
    
    
    self.tabBarController = [[[UITabBarController alloc] init] autorelease];
    self.tabBarController.viewControllers = [NSArray arrayWithObjects: viewController1, viewController2, nil];
    self.window.rootViewController = self.tabBarController;
    [self.window makeKeyAndVisible];
    
#else
    _didFindDelegate = nil;    
    _msrDelegate     = nil;
    
    g_pApp	= self;
    
    [self initPrinterController];
    
    uiView_Lookup = [[[UIViewController_PrinterLookup alloc] initWithNibName:@"UIViewController_PrinterLookup" bundle:nil] autorelease];
    uiView_PrintText = [[[UIViewController_PrintText alloc] initWithNibName:@"UIViewController_PrintText" bundle:nil] autorelease];
    uiView_Msr = [[[UIViewController_Msr alloc] initWithNibName:@"UIViewController_Msr" bundle:nil] autorelease];
    uiView_ImgBarcode = [[[UIViewController_Img_barcode alloc] initWithNibName:@"UIViewController_Img_barcode" bundle:nil] autorelease];
   
    uiView_Lookup.parent = uiView_PrintText.parent = uiView_Msr.parent = uiView_ImgBarcode.parent = self;
    
    self.tabBarController = [[[UITabBarController alloc] init] autorelease];
    self.tabBarController.viewControllers = [NSArray arrayWithObjects:/*viewController1, viewController2,*/ uiView_Lookup,  uiView_PrintText, uiView_Msr, uiView_ImgBarcode, nil];
    self.window.rootViewController = self.tabBarController;
    self.tabBarController.delegate = self;
    [self.window makeKeyAndVisible];
#endif
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    /*
     Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
     If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
     */
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    /*
     Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
     */
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    /*
     Called when the application is about to terminate.
     Save data if appropriate.
     See also applicationDidEnterBackground:.
     */
}

//////////////////////////////////////////////////////////////////////////////////
//  프린터 관련 내용 초기화 함수.
- (void)initPrinterController
{
    
    printerController          = [BXPrinterController getInstance];
    
    printerController.delegate = self;
    
    // Printer검색시 시도 회수 지정
    printerController.lookupCount	= 5;
    printerController.AutoConnection = BXL_CONNECTIONMODE_AUTO;
    
	[printerController open];
    
    

    NSLog(@"version : %@", printerController.version);
    
    //    // Printer 검색 시작
    //    [self refreshPrinterList];
    
}
//////////////////////////////////////////////////////////////////////////////////
//  프린터 관련 내용 마무리 함수.
- (void)releasePrinterController
{
	[printerController close];
	[printerController release];
    
}


//////////////////////////////////////////////////////////////////////////////////
//  Printer List 새로고침.
- (void)refreshPrinterList:(id)delegate
{
    _didFindDelegate = delegate;
    [printerController lookup];
}

- (long)msrReadStart:(id)delegate
{
    _msrDelegate = delegate;
    return [printerController msrReadReady];
}
- (void)msrReadEnd
{
    if([printerController msrIsReady])
        [printerController msrReadCancelEx];
    /************************************************************************************************
     * description
     *  1. msrReadCancelEx
     *     - The 'msrTerminated' protocol method is called after the 'msrReadCancelEx' completed.
     *  2. msrReadCancelEx
     *     - The 'msrTerminated' protocol method is not called after the 'msrReadCancelEx' completed.
     *    [example]
     *    if([printerController msrIsReady])  
     *        [printerController msrReadCancel];        
     ***********************************************************************************************/          
    
    
}

- (BXPrinterController*) getPrinterController
{
    return printerController;
}



//UIViewController_BXLPrinterMain_Delegate
#define __BXLPRINTER_DELEGATE_
#import "AppDelegate_BXLPrinterDelegate.m"
#undef __BXLPRINTER_DELEGATE_

@end
