//
//  UIViewController_BXLPrinterMain_Delegate.m
//  Demo
//
//  Created by Beomjin Kim on 11. 4. 25..
//  Copyright 2011 Zebra. All rights reserved.
//

#ifdef __BXLPRINTER_DELEGATE_

//////////////////////////////////////////////////////////////////////////////////////
// (+)sbson[2011.08.02] : Start  BXPrinterController's Delegate
//////////////////////////////////////////////////////////////////////////////////////
#pragma mark BXPrinterController delegate Methods
//////////////////////////////////////////////////////////////////////////////////////

- (void)message:(BXPrinterController *)controller
text:(NSString *)text
{
    NSLog(@"[Zebra Sample message] %@", text);
}



-(void)didUpdateStatus:(BXPrinterController*) controller
status:(NSNumber*) status
{    
    NSLog(@"didUpdateStatus");
}


- (void)msrArrived:(BXPrinterController *)controller 
track:(NSNumber *)track
{ 
    NSLog(@"msrArrived");
    if(_msrDelegate)
        [_msrDelegate didMsrDataIn:controller 
                             track:track];
}

- (void)msrTerminated:(BXPrinterController *)controller
{
    NSLog(@"msrTerminated");
    if(_msrDelegate)
        [_msrDelegate didMsrEnd];
}

- (void)willLookupPrinters:(BXPrinterController *)controller
{
    NSLog(@"willLookupPrinters");
    if(_didFindDelegate)
        [_didFindDelegate clearPrinterList];
    
}

- (void)didLookupPrinters:(BXPrinterController *)controller
{
}

- (void)didFindPrinter:(BXPrinterController *)controller 
printer:(BXPrinter *)printer
{
    NSLog(@"didFindPrinter");
    if(_didFindDelegate){
        [_didFindDelegate addPrinterList:printer];
    }    
}

- (void)willConnect:(BXPrinterController *)controller 
printer:(BXPrinter *)printer
{
    NSLog(@"willConnect");
}

- (void)didConnect:(BXPrinterController *)controller
printer:(BXPrinter *)printer
{
    NSLog(@"didConnect");
    if(_didFindDelegate){
        [_didFindDelegate didConnect];
    }
}

- (void)didNotConnect:(BXPrinterController *)controller
printer:(BXPrinter *)printer
withError:(NSError *)error
{
    NSLog(@"didNotConnect");
}

- (void)didDisconnect:(BXPrinterController *)controller
printer:(BXPrinter *)printer
{
    NSLog(@"didDisconnect");
}

- (void)didBeBrokenConnection:(BXPrinterController *)controller
printer:(BXPrinter *)printer
withError:(NSError *)error
{
    NSLog(@"didBeBrokenConnection");
}

#endif