//
//  BXLView_PrinterLookup.m
//  BxlPosDemo
//
//  Created by savin son on 12/15/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//


#define __lock      [_lock lock]
#define __unlock    [_lock unlock]

#import "AppDelegate.h"
#import "UIViewController_PrinterLookup.h"

#import "Common.h"
@implementation UIViewController_PrinterLookup

@synthesize parent, selectPrinter, uiLabel_Version, uiSwitch_AutoConnection;
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    	
    if (self) {        
        // Custom initialization
        [self initAllObject];
        self.title = NSLocalizedString(@"Lookup", @"Lookup");
        self.tabBarItem.image =[UIImage imageNamed:@"Config.png"];
    }
 
    
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle- (void)viewDidLoad
- (void)viewDidLoad
{
    [super viewDidLoad]; 
    // Do any additional setup after loading the view from its nib.
    
    [uiLabel_Version setText:[NSString stringWithFormat:@"            Use to Auto connection : "]];
    
    CGRect  rt = CGRectMake(250, 0, 10, 10);
    uiSwitch_AutoConnection = [[UISwitch    alloc]initWithFrame:rt];
    {
        [self.view addSubview:uiSwitch_AutoConnection];
        [uiSwitch_AutoConnection setOn:NO];
    }
    
    
    [parent refreshPrinterList:self];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
    
    [uiSwitch_AutoConnection release];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
//	return YES;
    
    return ((interfaceOrientation == UIInterfaceOrientationLandscapeLeft) ||  (interfaceOrientation == UIInterfaceOrientationLandscapeRight));
}
- (void) dealloc
{
    [super dealloc];
    
    [self releseAllObject];
    
}

//////////////////////////////////////////////////////////////////////////////////
//
- (void)clearPrinterList
{
	__lock;
	[_printersArrayBt removeAllObjects];
	[_printersArrayWifi removeAllObjects];
	[_printersArrayEthernet removeAllObjects];
    
    [(UITableView*) self.view reloadData];
	__unlock;
}
- (void)addPrinterList:(BXPrinter *)printer
{
    
    NSMutableArray* printersArray = nil;
    
    switch(printer.connectionClass)
    {
        case BXL_CONNECTIONCLASS_WIFI:
            printersArray = _printersArrayWifi;
//            
//            if([printersArray count] ==0)
//                printer.address = @"10.0.1.1";
//            
            break;
            
            
        case BXL_CONNECTIONCLASS_ETHERNET:
            printersArray = _printersArrayEthernet;
            break;
            
        case BXL_CONNECTIONCLASS_BT:
            printersArray = _printersArrayBt;
            break;
    }
    
    if(printersArray == nil)
        return;
    
    
	BOOL	bRefresh	= YES;
	
    [_lock lock];
	
	for( BXPrinter *p in printersArray )
	{
		if( [p.address isEqualToString:printer.address] )
		{
			bRefresh	= NO;
			break;
		}
	}

	if( bRefresh )
	{
		[printersArray addObject:printer];
		[(UITableView*)self.view reloadData];
	}
    [_lock unlock];
}

//////////////////////////////////////////////////////////////////////////////////
//  이 뷰 전반 적인 사항의 초기화 함수.
- (void)initAllObject
{
    _lock   = [NSLock new];
    
//    [self initPrinterController];
    [self initTableObject];
}

//////////////////////////////////////////////////////////////////////////////////
//  이 뷰 전반 적인 사항의 마무리 함수.
- (void)releseAllObject
{
 //   [self relesePrinterController];
    [self releseTableObject];
    
    [_lock release];
}

//////////////////////////////////////////////////////////////////////////////////
//  Table Controller 초기화 함수.
- (void)initTableObject
{
    _printersArrayWifi      = [NSMutableArray new]; 
    _printersArrayEthernet  = [NSMutableArray new]; 
    _printersArrayBt        = [NSMutableArray new]; 
    
    _posPrinterRefresh              = 0;
}
//////////////////////////////////////////////////////////////////////////////////
//  Table Controller 마무리 함수.
- (void)releseTableObject
{
	[_printersArrayWifi removeAllObjects];
    [_printersArrayWifi release];
    
	[_printersArrayEthernet removeAllObjects];
    [_printersArrayEthernet release];
    
	[_printersArrayBt removeAllObjects];
    [_printersArrayBt release];
    
}



//////////////////////////////////////////////////////////////////////////////////
//  Printer List 새로고침.
//  printer 에서 받은 응답 값을 전달해줄  view의 id. 
- (void) setCallerID:(id)_id
{
    _posViewId = _id;

}


- (void) didConnect
{
    
    BXPrinterController*    printerController = [parent getPrinterController];
    
		//  프린터 초기화 수행
		[printerController initializePrinter];
        //[printerController checkPrinter:BXL_MASK_MODELNAME];

        UIDevice    *device = [UIDevice currentDevice];
        if( BXL_SUCCESS != [printerController printText:[NSString stringWithFormat: \
                                                         @"\nconnected from %@\nhost: %@ / %@ %@\nSDK version for IOS: %@\n\n\n",
                                                          [Common localIPAddress],
                                                          device.model, device.systemName, device.systemVersion,
                                                          printerController.version]] )
        {
            //[getAlertManager() alert:NSLocalizedString(@"0000.Error", @"") message:@"checkprinter status is error"];
            NSLog(@"printText Fail");
            return;
        }
    
}
///////////////////////////////////////////////////////////
//  UISwitch Delegate


#define __BXLVIEW_DELEGATE_
#import "UIViewController_PrinterLookup_Tbl_delegate.m"
#undef __BXLVIEW_DELEGATE_


@end



















































