//
//  BXPrinterController_CashDrawer.m
//  Demo
//
//  Created by Beomjin Kim on 11. 4. 25..
//  Copyright 2011 Zebra. All rights reserved.
//

#ifdef __BXLVIEW_DELEGATE_

//////////////////////////////////////////////////////////////////////////////////////
// (+)sbson[2011.08.02] : Start  tableView's Delegate

//////////////////////////////////////////////////////////////////////////////////////
#pragma mark UITableView dataSource / delegate Methods
//////////////////////////////////////////////////////////////////////////////////////


- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
	return BXL_CONNECTIONCLASS_BT+2;   //  WIFI,  Ethernet , Refresh Section
}

- (NSInteger)tableView:(UITableView *)tableView
numberOfRowsInSection:(NSInteger)section
{
#if 0
	int		count	= 1;
	
    count   = _printersArrayWifi.count+1;

	_posPrinterRefresh = count-1;
#endif
    
    
    NSMutableArray* printersArray = nil;
    switch(section)
    {
        case BXL_CONNECTIONCLASS_WIFI:
            printersArray = _printersArrayWifi;
            break;
        case BXL_CONNECTIONCLASS_ETHERNET:
            printersArray = _printersArrayEthernet;
            break;        
        case BXL_CONNECTIONCLASS_BT:
            printersArray = _printersArrayBt;
            break;        
    }
    
	int		count	= 1;
    if(printersArray)
        count   = printersArray.count;
    
    _posPrinterRefresh = 0;//  Refresh Section을 별도로 생성하면서, _posPrinterRefresh 가 쓸모 없어졌음.
    
	return count;
}

- (NSString *)tableView:(UITableView *)tableView
titleForHeaderInSection:(NSInteger)section
{
    switch(section)
    {
        case BXL_CONNECTIONCLASS_WIFI:
            return @"Searched printers via to WIFI";
        case BXL_CONNECTIONCLASS_ETHERNET:
            return @"Searched printers via to Ethernet";
        case 2://BXL_CONNECTIONCLASS_BT:
            return @"Searched printers via to Bluetooth";
        default:;
    }
	return @"";//@"Searched printers";
}

- (NSString *)tableView:(UITableView *)tableView
titleForFooterInSection:(NSInteger)section
{
    int     count   = 0;
    
    switch(section)
    {
        case BXL_CONNECTIONCLASS_WIFI:
            count   = _printersArrayWifi.count;
            return [NSString stringWithFormat:@"%d printer(s) found.", count];
        case BXL_CONNECTIONCLASS_ETHERNET:
            count   = _printersArrayEthernet.count;
            return [NSString stringWithFormat:@"%d printer(s) found.", count];
        case 2://BXL_CONNECTIONCLASS_BT:
            count   = _printersArrayBt.count;
            return [NSString stringWithFormat:@"%d printer(s) found.\n\nIf you want to connect to a printer and print, please tap the address of printer.", count];
        default:;
    }
    
    return @"";
    
}

- (UITableViewCell *)getCell:(UITableView *)_tableView
{
	static NSString	*reuseId	= @"PrinterCell";
	
	UITableViewCell	*cell	= [_tableView dequeueReusableCellWithIdentifier:reuseId];
	
	if( nil == cell )
	{
        cell    = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault
                                         reuseIdentifier:nil];//reuseId];
        
	}	
	return cell;	
}

- (CGFloat)tableView:(UITableView *)tableView 
heightForRowAtIndexPath:(NSIndexPath *)indexPath
{		
	int	height	= 45;	
	return height;
}

///////////////////////////////////////////////////////////////////////////////////
// 보여줄 Cell 생성
///////////////////////////////////////////////////////////////////////////////////
- (UITableViewCell *)tableView:(UITableView *)_tableView
cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    UITableViewCell *cell       = [self getCell:_tableView];
    

        if( indexPath.section== _tableView.numberOfSections-1 
           && indexPath.row==_posPrinterRefresh)       //indexPath.length)
        {
            cell.textLabel.text = @"Refresh to printer list...";
        }
        else
        {            
            NSMutableArray* printersArray = nil;
            
            switch(indexPath.section)
            {
                case BXL_CONNECTIONCLASS_WIFI:
                    printersArray = _printersArrayWifi;
                    break;
                case BXL_CONNECTIONCLASS_ETHERNET:
                    printersArray = _printersArrayEthernet;
                    break;
                case BXL_CONNECTIONCLASS_BT:
                    printersArray = _printersArrayBt;
                    break;        
                    
            }
            
            if(printersArray){
                if(indexPath.row >= [printersArray count])
                {  
                    return cell;
                }
                BXPrinter       *printer    = [printersArray objectAtIndex:indexPath.row];
                if(printer.connectionClass == BXL_CONNECTIONCLASS_BT)
                    cell.textLabel.text  = [NSString stringWithFormat:@"%@ (%@)", printer.name, printer.macAddress ];//printer.name;
                else
                    cell.textLabel.text  = [NSString stringWithFormat:@"%@ (%@)", printer.address, printer.macAddress ];
                //cell.imageView.image = [UIImage imageNamed:@"printer.png"];
            }
        }
        
    
	return cell;
}


///////////////////////////////////////////////////////////////////////////////////
// Printer가 선택되었다.
///////////////////////////////////////////////////////////////////////////////////
- (NSIndexPath *)tableView:(UITableView *)tableView 
willSelectRowAtIndexPath:(NSIndexPath *)indexPath
{	
	return indexPath;
}

- (NSIndexPath *)tableView:(UITableView *)tableView 
willDeselectRowAtIndexPath:(NSIndexPath *)indexPath
{
	return indexPath;
}

- (void)tableView:(UITableView *)tableView
didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{ 
    
    NSMutableArray* printersArray = nil;
    switch(indexPath.section)
    {
        case BXL_CONNECTIONCLASS_WIFI:
            printersArray = _printersArrayWifi;
            break;
        case BXL_CONNECTIONCLASS_ETHERNET:
            printersArray = _printersArrayEthernet;
            break;
        case BXL_CONNECTIONCLASS_BT:
            printersArray = _printersArrayBt;
            [uiSwitch_AutoConnection setOn:NO];
            break;
        
    }
    if(printersArray == nil){
        [parent refreshPrinterList:self];
        return;   
    }
    
    
    if(indexPath.section == tableView.numberOfSections-1)// indexPath.row >=_posPrinterRefresh)
    {    
        [parent refreshPrinterList:self];
    }
	@try
	{\
		__lock;
        
        if(indexPath.row >= [printersArray count])
        {            
            return;            
        }
		
		BXPrinterController*    printerController = [parent getPrinterController];

        /* Disconnect to Connected printer */
        if(printerController.target)
            [printerController disconnectWithTimeout:3];

        /* Printer Select */
        self.selectPrinter   = [printersArray objectAtIndex:indexPath.row]; 
        printerController.target = self.selectPrinter;
        
		if(BXL_SUCCESS != [printerController selectTarget]) {
            NSLog(@"There is a problem with selected printer. You might need to refresh this list.");
            return;
		}
        
        /* Connection Mode Check */
        if([uiSwitch_AutoConnection isOn] == NO)
        {
            //   Connection control ==>  Manual Mode
            printerController.AutoConnection = BXL_CONNECTIONMODE_NOAUTO;
            if([printerController connect] == NO ){
                NSLog(@"Failed to connect.");
                return;
            }
        }
        else{
            printerController.AutoConnection = BXL_CONNECTIONMODE_AUTO;
        }
//
// Sbin(-) for iOS 6.1 [2013/02/12]
// Move to didConnect
//		//  프린터 초기화 수행
//		[printerController initializePrinter];
//        //[printerController checkPrinter:BXL_MASK_MODELNAME];
//        
//        UIDevice    *device = [UIDevice currentDevice];
//        if( BXL_SUCCESS != [printerController printText:[NSString stringWithFormat: \
//                                                         @"\nconnected from %@\nhost: %@ / %@ %@\nSDK version for IOS: %@\n\n\n",
//                                                          [Common localIPAddress],
//                                                          device.model, device.systemName, device.systemVersion,
//                                                          printerController.version]] )
//        {
//            //[getAlertManager() alert:NSLocalizedString(@"0000.Error", @"") message:@"checkprinter status is error"];	
//            NSLog(@"printText Fail");
//            return;
//        }	
		
	}
	@finally 
	{
		//[self refresh];
		__unlock;
	} 

	
}

- (void)tableView:(UITableView *)tableView
commitEditingStyle:(UITableViewCellEditingStyle)editingStyle
forRowAtIndexPath:(NSIndexPath *)indexPath
{
}

- (BOOL)tableView:(UITableView *)tableView 
canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
	return YES;
}

- (UITableViewCellEditingStyle)tableView:(UITableView *)tableView
editingStyleForRowAtIndexPath:(NSIndexPath *)indexPath
{	
	return UITableViewCellEditingStyleNone;
}

- (void)tableView:(UITableView *)tableView 
willBeginEditingRowAtIndexPath:(NSIndexPath *)indexPath
{
	
}

- (void)tableView:(UITableView *)tableView 
didEndEditingRowAtIndexPath:(NSIndexPath *)indexPath
{
}

// (+)sbson[2011.08.02] : End  tableView's Delegate

#endif