//
//  UIViewController_Img_barcode.m
//  ZebraExam
//
//  Created by savin son on 3/21/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "UIViewController_Img_barcode.h"
#import "AppDelegate.h"

@implementation UIViewController_Img_barcode
@synthesize uiBtn_Barcode, parent;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
        
        self.title = NSLocalizedString(@"Img/Barcode", @"Img/Barcode");
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return ((interfaceOrientation == UIInterfaceOrientationLandscapeLeft) ||  (interfaceOrientation == UIInterfaceOrientationLandscapeRight));

}

- (IBAction)buttonUp_PrintImage:(UIButton *)button
{
    
    BXPrinterController*    printerController = [parent getPrinterController];    
	[printerController printBitmapWithImage:[UIImage imageNamed:@"logo-zebra.png"] width:BXL_WIDTH_FULL 
                                       level:1050];
}

- (IBAction)buttonUp_PrintBarcode:(UIButton *)button
{    
     BXPrinterController*    printerController = [parent getPrinterController];    
    NSMutableArray *tbl = [printerController getBarcodeSupportTable];
    
    for(BXBarcode *p in tbl)
    {        
        NSLog(@"Barcode : %d [%@] - %d", p.barNumber, p.name, p.support);
        
        if(p.support){
            NSString*	strBarcodeText = @"";
            
            
            switch (p.barNumber) {
                case BXL_BCS_UPCA:
                case BXL_BCS_UPCE:
                    strBarcodeText = @"012345678901";;
                    break;
                case BXL_BCS_JAN13:
                case BXL_BCS_EAN13:
                case BXL_BCS_Code39:
                case BXL_BCS_Code93:
                    strBarcodeText = @"123456789012";
                    break;
                case BXL_BCS_ITF:
                    strBarcodeText = @"1234567890";
                    break;
                case BXL_BCS_Codabar:
                    strBarcodeText = @"C123";
                    break;
                case BXL_BCS_Code128:
                    	strBarcodeText = @"{B1234abcd!@#$";
                    //  strBarcodeText = @"{A1234ABCD!@#$";
                    break;
                case BXL_BCS_QRCODE_MODEL1:
                case BXL_BCS_QRCODE_MODEL2:
                case BXL_BCS_PDF417:
                case BXL_BCS_MAXICODE_MODE2:
                case BXL_BCS_MAXICODE_MODE3:
                case BXL_BCS_MAXICODE_MODE4:
                    
                    strBarcodeText = @"012345678901abcdefg!@#$%!@#";

                    break;
                    
                case BXL_BCS_JAN8:
                case BXL_BCS_EAN8:
                default:
                    strBarcodeText = @"12345678";
                    break;
            }
            
            
            
            char	*code	= (char *)[strBarcodeText cStringUsingEncoding:[NSString defaultCStringEncoding]];
            int		ret = BXL_SUCCESS;
            
            ret = [printerController printBarcode:code
                                        symbology:p.barNumber
                                            width:3
                                           height:100];
            
            if(ret !=  BXL_SUCCESS)
                [printerController printText: [NSString stringWithFormat:@"\r\n\r\n %@ is Not Support\r\n", p.name]];
            
            
        }
        
    }

}
@end
